package kanaida.panel_example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "kanaida.panel_example", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "kanaida.panel_example", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.PanelWrapper _mainpanel = null;
public anywheresoftware.b4a.objects.PanelWrapper _panel1 = null;
public anywheresoftware.b4a.objects.PanelWrapper _panel2 = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _spinner1 = null;
public anywheresoftware.b4a.objects.ListViewWrapper _p1list1 = null;
public anywheresoftware.b4a.objects.ListViewWrapper _p2list1 = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 22;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(2097152);
 BA.debugLineNum = 23;BA.debugLine="MainPanel.Initialize(\"\")";
Debug.ShouldStop(4194304);
mostCurrent._mainpanel.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 24;BA.debugLine="Panel1.Initialize(\"\")";
Debug.ShouldStop(8388608);
mostCurrent._panel1.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 25;BA.debugLine="Panel1.Color = Colors.Blue";
Debug.ShouldStop(16777216);
mostCurrent._panel1.setColor(anywheresoftware.b4a.keywords.Common.Colors.Blue);
 BA.debugLineNum = 26;BA.debugLine="Panel2.Initialize(\"\")";
Debug.ShouldStop(33554432);
mostCurrent._panel2.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 27;BA.debugLine="Panel2.Color = Colors.Green";
Debug.ShouldStop(67108864);
mostCurrent._panel2.setColor(anywheresoftware.b4a.keywords.Common.Colors.Green);
 BA.debugLineNum = 30;BA.debugLine="MainPanel.AddView(Panel1,0,0,100%x,100%y)";
Debug.ShouldStop(536870912);
mostCurrent._mainpanel.AddView((android.view.View)(mostCurrent._panel1.getObject()),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA));
 BA.debugLineNum = 31;BA.debugLine="MainPanel.AddView(Panel2,0,0,100%x,100%y)";
Debug.ShouldStop(1073741824);
mostCurrent._mainpanel.AddView((android.view.View)(mostCurrent._panel2.getObject()),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA));
 BA.debugLineNum = 34;BA.debugLine="Activity.AddView(MainPanel,0,0,100%x,90%y)";
Debug.ShouldStop(2);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._mainpanel.getObject()),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(90),mostCurrent.activityBA));
 BA.debugLineNum = 37;BA.debugLine="Spinner1.Initialize(\"spinner1\")";
Debug.ShouldStop(16);
mostCurrent._spinner1.Initialize(mostCurrent.activityBA,"spinner1");
 BA.debugLineNum = 38;BA.debugLine="Spinner1.Add(\"Panel1\")";
Debug.ShouldStop(32);
mostCurrent._spinner1.Add("Panel1");
 BA.debugLineNum = 39;BA.debugLine="Spinner1.Add(\"Panel2\")";
Debug.ShouldStop(64);
mostCurrent._spinner1.Add("Panel2");
 BA.debugLineNum = 40;BA.debugLine="Activity.AddView(Spinner1,0,90%y,100%x,10%y)";
Debug.ShouldStop(128);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._spinner1.getObject()),(int)(0),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(90),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(10),mostCurrent.activityBA));
 BA.debugLineNum = 43;BA.debugLine="p1List1.Initialize(\"\")";
Debug.ShouldStop(1024);
mostCurrent._p1list1.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 44;BA.debugLine="p1List1.AddSingleLine(\"Line 1\")";
Debug.ShouldStop(2048);
mostCurrent._p1list1.AddSingleLine("Line 1");
 BA.debugLineNum = 45;BA.debugLine="p1List1.AddSingleLine(\"Line 2\")";
Debug.ShouldStop(4096);
mostCurrent._p1list1.AddSingleLine("Line 2");
 BA.debugLineNum = 46;BA.debugLine="Panel1.AddView(p1List1,0,0,100%x,50%y)";
Debug.ShouldStop(8192);
mostCurrent._panel1.AddView((android.view.View)(mostCurrent._p1list1.getObject()),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(50),mostCurrent.activityBA));
 BA.debugLineNum = 48;BA.debugLine="p2List1.Initialize(\"\")";
Debug.ShouldStop(32768);
mostCurrent._p2list1.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 49;BA.debugLine="p2List1.AddTwoLines(\"Panel 2\",\"Line 1\")";
Debug.ShouldStop(65536);
mostCurrent._p2list1.AddTwoLines("Panel 2","Line 1");
 BA.debugLineNum = 50;BA.debugLine="p2List1.AddTwoLines(\"Panel 2\",\"Line 2\")";
Debug.ShouldStop(131072);
mostCurrent._p2list1.AddTwoLines("Panel 2","Line 2");
 BA.debugLineNum = 51;BA.debugLine="Panel2.AddView(p2List1,0,0,100%x,50%y)";
Debug.ShouldStop(262144);
mostCurrent._panel2.AddView((android.view.View)(mostCurrent._p2list1.getObject()),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(50),mostCurrent.activityBA));
 BA.debugLineNum = 62;BA.debugLine="ShowPanel1";
Debug.ShouldStop(536870912);
_showpanel1();
 BA.debugLineNum = 63;BA.debugLine="End Sub";
Debug.ShouldStop(1073741824);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 93;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(268435456);
 BA.debugLineNum = 95;BA.debugLine="End Sub";
Debug.ShouldStop(1073741824);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 89;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(16777216);
 BA.debugLineNum = 91;BA.debugLine="End Sub";
Debug.ShouldStop(67108864);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 21023, new int[] {3}, "f12aaf9f-1ff8-4245-a576-a3f1337aaa33");}

    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}

}
public static String  _globals() throws Exception{
 BA.debugLineNum = 8;BA.debugLine="Sub Globals";
 BA.debugLineNum = 11;BA.debugLine="Dim MainPanel As Panel";
mostCurrent._mainpanel = new anywheresoftware.b4a.objects.PanelWrapper();
 BA.debugLineNum = 12;BA.debugLine="Dim Panel1 As Panel";
mostCurrent._panel1 = new anywheresoftware.b4a.objects.PanelWrapper();
 BA.debugLineNum = 13;BA.debugLine="Dim Panel2 As Panel";
mostCurrent._panel2 = new anywheresoftware.b4a.objects.PanelWrapper();
 BA.debugLineNum = 14;BA.debugLine="Dim Spinner1 As Spinner";
mostCurrent._spinner1 = new anywheresoftware.b4a.objects.SpinnerWrapper();
 BA.debugLineNum = 18;BA.debugLine="Dim p1List1 As ListView";
mostCurrent._p1list1 = new anywheresoftware.b4a.objects.ListViewWrapper();
 BA.debugLineNum = 19;BA.debugLine="Dim p2List1 As ListView";
mostCurrent._p2list1 = new anywheresoftware.b4a.objects.ListViewWrapper();
 BA.debugLineNum = 20;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 BA.debugLineNum = 2;BA.debugLine="Sub Process_Globals";
 BA.debugLineNum = 6;BA.debugLine="End Sub";
return "";
}
public static String  _showpanel1() throws Exception{
		Debug.PushSubsStack("ShowPanel1 (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 65;BA.debugLine="Sub ShowPanel1";
Debug.ShouldStop(1);
 BA.debugLineNum = 66;BA.debugLine="Panel1.Visible = True";
Debug.ShouldStop(2);
mostCurrent._panel1.setVisible(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 67;BA.debugLine="Panel1.BringToFront";
Debug.ShouldStop(4);
mostCurrent._panel1.BringToFront();
 BA.debugLineNum = 69;BA.debugLine="Panel2.Visible = False";
Debug.ShouldStop(16);
mostCurrent._panel2.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 70;BA.debugLine="End Sub";
Debug.ShouldStop(32);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _showpanel2() throws Exception{
		Debug.PushSubsStack("ShowPanel2 (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 72;BA.debugLine="Sub ShowPanel2";
Debug.ShouldStop(128);
 BA.debugLineNum = 73;BA.debugLine="Panel1.Visible = False";
Debug.ShouldStop(256);
mostCurrent._panel1.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 75;BA.debugLine="Panel2.Visible = True";
Debug.ShouldStop(1024);
mostCurrent._panel2.setVisible(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 76;BA.debugLine="Panel2.BringToFront";
Debug.ShouldStop(2048);
mostCurrent._panel2.BringToFront();
 BA.debugLineNum = 77;BA.debugLine="End Sub";
Debug.ShouldStop(4096);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _spinner1_itemclick(int _position,Object _value) throws Exception{
		Debug.PushSubsStack("Spinner1_ItemClick (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Position", _position);
Debug.locals.put("Value", _value);
 BA.debugLineNum = 79;BA.debugLine="Sub Spinner1_ItemClick (Position As Int, Value As Object)";
Debug.ShouldStop(16384);
 BA.debugLineNum = 80;BA.debugLine="Select Case Value";
Debug.ShouldStop(32768);
switch (BA.switchObjectToInt(_value,(Object)("Panel1"),(Object)("Panel2"))) {
case 0:
 BA.debugLineNum = 82;BA.debugLine="ShowPanel1";
Debug.ShouldStop(131072);
_showpanel1();
 break;
case 1:
 BA.debugLineNum = 85;BA.debugLine="ShowPanel2";
Debug.ShouldStop(1048576);
_showpanel2();
 break;
}
;
 BA.debugLineNum = 87;BA.debugLine="End Sub";
Debug.ShouldStop(4194304);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity,"MainPanel",_mainpanel,"Panel1",_panel1,"Panel2",_panel2,"Spinner1",_spinner1,"p1List1",_p1list1,"p2List1",_p2list1};
}
}
